'**************************************
'
' C-Control/BASIC       I2C.BAS
'
' Aufgabe:
'
' - Porterweiterung ueber den I2C-Bus
' - Ansteuerung eines PCF8574
'
'**************************************
' --- Definitionen --------------------

define SDA port[9]
define SCL port[10]
define Daten byte
define Zaehler byte
define N byte

' --- Programmoperationen -------------

SDA = ON
SCL = ON


#Loop
  for Zaehler = 0 to 255
    gosub Start
    Daten = 64      'Adresse PCF8574
    gosub I2C_Write
    Daten = Zaehler
    gosub I2C_Write
    gosub Stop
    gosub Start
    Daten = 65      'PCF8574, Lesen
    gosub I2C_Write
    gosub I2C_Read
    print Daten
    gosub NoAck
    gosub Stop
  next

goto Loop           'Endlosschleife

#Start
  SDA = OFF
  SCL = OFF
  return

#Stop
  SDA = OFF
  SCL = ON
  SDA = ON
  return

#I2C_WRITE
  for N = 1 to 8
    SDA= OFF
    if (Daten AND 128) = 128 then SDA = ON
    pulse SCL
    Daten = Daten shl 1 '1 Bit nach links
  next
  pulse SCL             ' 9. Impuls
  return

#I2C_Read
  Daten = 0
  deact SDA           ' SDA = Eingang
  for N = 1 to 8
    Daten = Daten shl 1 '1 Bit nach links
    SCL = ON
    if SDA then Daten = Daten + 1
    SCL = OFF
  next
  return

#Ack
  SDA = 0
  pulse SCL
  return

#NoAck
  SDA = 1
  pulse SCL
  return

end



